Subject: DateFormat View Helper doesn't respect locale setting

Description

Hi [this is related to fluid, | don't know if this is the right bugtracker],

just found out that the format date viewhelper does not support local date settings (day or month names etc) because it uses the
DateFormat object that does not care for the locale.

A short test case shows this:

dateTime->format('l, d. F Y'): Monday, 30. November 2009
stritime('%A, %d. %B %G'): Monday, 30. November 2009

setlocale(LC_ALL, 'de_DE.utf8'");

dateTime->format('l, d. F Y'): Monday, 30. November 2009
strftime('%A, %d. %B %G'): Montag, 30. November 2009

(compare "Monday" and "Montag" in the last part)

Code:

$dateTime = new DateTime();

echo 'dateTime->format(\'l, d. F Y\'):";
echo $dateTime->format(l, d. F Y');
echo 'stritime(\'%A, %d. %B %G\):';
echo strftime('%A, %d. %B %G');
echo "\n";

echo 'setlocale(LC_ALL, \'de_DE.utf8\")" . "\n\n";
setlocale(LC_ALL, 'de_DE.utf8'");
echo 'dateTime->format(\'l, d. F Y\"):";
echo $dateTime->format('l, d. F Y');
echo 'stritime(\'%A, %d. %B %G\):";
echo strftime('%A, %d. %B %G');

We could probably use strftime for locales other than en_US (or always?). If you think that reasonable I'll try making a patch at the
weekend.

Related issues:

related to news extension - Task # 14085: translate newsltem.datetime in FE Resolved 2011-03-28
duplicates TYPO3.Fluid - Bug # 4972: f:format.date does not respect locale. Closed 2009-10-12
History

#1 - 2010-06-25 18:47 - Franz Koch
any news on that? It's a shame that dates don't get localized by the dateTime object of PHP. | solved it for now by using my own viewHelper, but that's

no overall solution.

#2 - 2011-01-11 14:52 - Sebastian Kurfuerst
- Tracker changed from Bug to Story
- Status changed from New to Needs Feedback

For now, | suggest to use a second ViewHelper -- if you have one, please post it to the VH incubator. We'd love to see one soon :-)
Greets,

Sebastian

#3 - 2011-01-11 14:53 - Sebastian Kurfuerst

- Project changed from Extbase MVC Framework to TYPOGS.Fluid

#4 - 2011-01-11 14:53 - Sebastian Kurfuerst

- Category set to ViewHelpers

- Branch set to v4 + v5

#5 - 2011-05-06 10:19 - Sebastian Kurfuerst

- Status changed from Needs Feedback to Closed

duplicate
